%macro PBFunction 1 ;Thx Fred for this handy-macro
  GLOBAL PB_%1
PB_%1:
%endmacro

EXTERN _fgetc@4

EXTERN _HeapAlloc@12
EXTERN _HeapFree@12

EXTERN PB_MemoryBase

%macro Searchnexttext 1
  %%loopstart:
  CMP byte[%1], 32
  JE %%inc
  CMP byte[%1], 10
  JE %%inc
  CMP byte[%1], 13
  JE %%inc
  CMP byte[%1], 9
  JNE %%loopend
  %%inc:
  INC %1
  JMP %%loopstart
  %%loopend:
%endmacro

%macro Searchnextws 1
  %%loopstart:
  CMP byte[%1], 32
  JE %%loopend
  CMP byte[%1], 10
  JE %%loopend
  CMP byte[%1], 13
  JE %%loopend
  CMP byte[%1], 9
  JE %%loopend
  INC %1
  JMP %%loopstart
  %%loopend:
%endmacro

%macro MemReadNextByte 2 ;(Src, dest)
  MOV %2, [%1]
  LEA %1, [%1+1]
  CMP %2, 35
  JNE %%return

  %%loopstart:
  MOV %2, [%1]
  LEA %1, [%1+1]
  CMP %2, 10
  JE %%return
  CMP %2, 13
  JNE %%loopstart

  %%return:
%endmacro

%macro ReadNextByte 0
  CALL _fgetc@4
  CMP Eax, 35
  JNE %%return

  %%loopstart:
  CALL _fgetc@4
  CMP Eax, 10
  JE %%return
  CMP Eax, 13
  JNE %%loopstart

  %%return:
%endmacro

%macro ReadNextVal 0
  %%loopstart:
  ReadNextByte
  CMP Eax, 32
  JE %%loopstart
  CMP Eax, 10
  JE %%loopstart
  CMP Eax, 13
  JE %%loopstart
  CMP Eax, 9
  JE %%loopstart

  SUB Eax, 48

  POP Edx
  PUSH Eax
  PUSH Edx

  %%loop2start:
  ReadNextByte
  CMP Eax, 32
  JE %%loop2end
  CMP Eax, 10
  JE %%loop2end
  CMP Eax, 13
  JE %%loop2end
  CMP Eax, 9
  JE %%loop2end

  NOP

  SUB Eax, 48
  JNAE %%loop2start
  MOV Ecx, dword[Esp+4]
  LEA Ecx, [Ecx+Ecx*4] ;*5
  LEA Ecx, [Eax+Ecx*2] ;*2 + Eax
  MOV dword[Esp+4], Ecx
  JMP %%loop2start

  %%loop2end


  POP Edx
  POP Eax
  PUSH Edx

%endmacro

SEGMENT .text USE32 CLASS=code

Val: ;(Mem, MemEnd) Ecx, Edx (ende nicht eingeschlossen)
  XOR Eax, Eax
  SUB Edx, Ecx
  JBE .Return
  .Loop:

  ADD al, byte[Ecx]
  SUB al, 48
  JNAE .Return
  DEC Edx
  JZ .Return
  LEA Eax, [Eax+Eax*4] ;*5
  ADD Eax, Eax         ;*2

  ADD al, byte[Ecx+1]
  SUB al, 48
  JNAE .Return
  DEC Edx
  JZ .Return
  LEA Eax, [Eax+Eax*4] ;*5
  ADD Eax, Eax         ;*2

  ADD al, byte[Ecx+2]
  SUB al, 48
  JNAE .Return
  DEC Edx
  JZ .Return
  LEA Eax, [Eax+Eax*4] ;*5
  ADD Eax, Eax         ;*2

  ADD al, byte[Ecx+3]
  SUB al, 48
  JNAE .Return
  DEC Edx
  JZ .Return
  LEA Eax, [Eax+Eax*4] ;*5
  ADD Eax, Eax         ;*2

  ADD Ecx, 4
  JMP .Loop
  .Return
RET

Check: ;(File, Memory, Filename)
  CMP dword[Esp+4], 0
  JNE near .CheckFile
    MOV Edx, dword[Esp+8] ;Memory
    CMP word[Edx], 12624;'1P' ;P1
    JNE near .Check_P4

    ADD Edx, 2
    Searchnexttext Edx
    MOV Ecx, Edx
    Searchnextws Edx
    PUSH Edx ;->

    CALL Val
    MOV dword[ImageWidth], Eax

    POP Edx  ;<-
    Searchnexttext Edx
    MOV Ecx, Edx
    Searchnextws Edx
    PUSH Edx ;->
    CALL Val
    MOV dword[ImageHeight], Eax

    POP dword[ImageData] ;<-
    MOV dword[ImageDataA], 0

    XOR Eax, Eax
    INC Eax
    JMP .Return

    .Check_P4: ;(not supported yet)
    CMP word[Edx], '4P' ;P4
    JNE .Return_Null
    XOR Eax, Eax
    ;INC Eax
    JMP .Return

  .Return_Null:
  XOR Eax, Eax
  .Return:
RET 12


  .CheckFile:
  PUSH dword[Esp+4]
  CALL _fgetc@4  ;dont restore Stack, because another use...
  CMP Eax, 80
  JNE .Return_Null

  CALL _fgetc@4 ;...here...
  CMP Eax, 49
  JNE near .FileCheck_P4

  ReadNextVal ;...and here...
  MOV dword[ImageWidth], Eax

  ReadNextVal ;...and here...
  MOV dword[ImageHeight], Eax

  MUL dword[ImageWidth]
  POP Edx
  PUSH Eax
  PUSH Edx

  PUSH Eax
  PUSH 0
  PUSH dword[PB_MemoryBase]
  CALL _HeapAlloc@12
  MOV dword[ImageData], Eax
  MOV dword[ImageDataA], 1

  POP Edx
  PUSH Eax
  PUSH Edx

  ;(Stack) -> FileStream|ImageDataBuffer|ImageSize

  .ReadImageDataLoop:
  ReadNextByte ;...and here
  CMP Eax, 48 ;0
  JE .ReadImageDataLoop_i1
  CMP Eax, 49 ;1
  JNE .ReadImageDataLoop
  .ReadImageDataLoop_i1:
  MOV Edx, dword[Esp+4]
  MOV byte[Edx], al
  INC dword[Esp+4]
  DEC dword[Esp+8]
  JNZ .ReadImageDataLoop

  ADD Esp, 4*3

  XOR Eax, Eax
  INC Eax
RET 12

  .FileCheck_P4:
  CMP Eax, 52
  JNE .Return_Null

  XOR Eax, Eax ;not supported
RET 12

GetWidth:
  MOV Eax, dword[ImageWidth]
RET

GetHeight:
  MOV Eax, dword[ImageHeight]
RET

Decode:  ;(*Buffer, LinePitch, Format)
  CMP dword[ImageData], 0
  JE near .Return
    PUSH Esi
    PUSH Ebx

    MOV Eax, dword[Esp+12] ;Buffer
    MOV Esi, dword[ImageData]
    MOV Edx, dword[ImageWidth]
    MOV Ebx, dword[ImageHeight]

    .MainLoop:
    MemReadNextByte Esi, cl
    CMP cl, 48
    JE .WriteWhite
    CMP cl, 49
    JNE .MainLoop ;JE .WriteBlack

    .WriteBlack
    MOV word[Eax],   0
    MOV byte[Eax+2], 0
    ADD Eax, 3
    DEC Edx
    JZ .NextLine
    JMP .MainLoop


    .WriteWhite:
    MOV word[Eax],   0xFFFF
    MOV byte[Eax+2], 0xFF
    ADD Eax, 3
    DEC Edx
    JZ .NextLine
    JMP .MainLoop

    .NextLine:
    MOV Ecx, dword[Esp+16] ;LinePitch
    MOV Edx, dword[ImageWidth]
    ADD dword[Esp+12], Ecx
    MOV Eax, dword[Esp+12] ;Buffer
    DEC Ebx
    JNZ .MainLoop

    .MainLoopEnd:
    POP Ebx
    POP Esi

    CMP dword[ImageDataA], 0
    JE .Return

    PUSH dword[ImageData]
    PUSH 0
    PUSH dword[PB_MemoryBase]
    CALL _HeapFree@12

  .Return:
RET 12

EXTERN _PB_ImageDecoder_Register@4

PBFunction UsePBMImageDecoder
  CMP dword[Registered], 0
  JNE .Return

 		MOV dword[ImageDecoder+ 0], Check
 		MOV dword[ImageDecoder+ 4], Decode
 		MOV dword[ImageDecoder+ 8], GetWidth
 		MOV dword[ImageDecoder+12], GetHeight

    PUSH ImageDecoder
    CALL _PB_ImageDecoder_Register@4

    INC dword[Registered]
  .Return:
RET

SEGMENT .data CLASS=Data
Registered: dd 0

SEGMENT .bss CLASS=Data
ImageData: resd 1
ImageDataA: resd 1
ImageWidth: resd 1
ImageHeight: resd 1
ImageDecoder: resd 4
